/// <reference types="jasmine" />
import { Setup } from './setup';
/** Class for mocking objects/interfaces in Typescript */
export declare class Mock<T> {
    /**
     * Can be used to define empty methods when using extend
     * mock.extend({ someMethod: Mock.ANY_FUNC });
    */
    static ANY_FUNC: () => any;
    /** Create mock from a Type */
    static of<T>(type: {
        new (): T;
    }): Mock<T>;
    static static<T, K extends keyof T>(obj: T, key: K, stub: T[K] & Function): void;
    private _object;
    private _spies;
    constructor(object?: Partial<{
        [key in keyof T]: T[key];
    }> | T);
    /** Return the mocked object */
    readonly Object: T;
    /** Extend the current mock object with implementation */
    extend(object: Partial<{
        [key in keyof T]: T[key];
    }>): this;
    /** Setup a property or a method with using lambda style settings */
    setup<TProp>(value: (obj: T) => TProp): Setup<T, TProp>;
    private getPropertyName<TProp>(value);
    /** Get the spy of method or property that has be
     *  set with extend of setup/is
     *  REMARK:
     */
    spyOf<TProp>(value: (obj: T) => TProp): jasmine.Spy;
}
